Subject: [i2rs] RIB information model - replacing RBNF with UML and RBNF

From: "Susan Hares" <[email-masked]>
Date: Mon, 28 Apr 2014 18:30:26 -0400

Hi all:

I have attached a revision to the RIB info-model that replaces RBNF with UML
and yang topology drafts.  I am hoping to have a discussion of the UML with
an approved draft before launching the UML/Yang topology models for the PBR
and BGP drafts. 

This was posted ~1 weeks ago, but the chairs suggest this go on another list
rather than the yang/forces discussion. To enforce this, the files were not
sent to the general i2rs list.  Some people were directly copied so a brief
discussion occurred on list. Hopefully, under this new header all the files
will be forwarded for discussions. 

This document inherits the yang data trees (as pseudo informational models
from)  the following locations as 

ietf-netmod-routing-cfg-13 has this chart that indicates 
 
   +--------+---------------------------+-----------+
   | Prefix | YANG module               | Reference |
   +--------+---------------------------+-----------+
   | if     | ietf-interfaces           | [YANG-IF
<http://tools.ietf.org/html/draft-ietf-netmod-routing-cfg-13#ref-YANG-IF> ]
|
   |        |                           |           |
   | ip     | ietf-ip                   | [YANG-IP
<http://tools.ietf.org/html/draft-ietf-netmod-routing-cfg-13#ref-YANG-IP> ]
|
   |        |                           |           |
   | rt     | ietf-routing              | Section 7 |
   |        |                           |           |
   | v4ur   | ietf-ipv4-unicast-routing | Section 8
<http://tools.ietf.org/html/draft-ietf-netmod-routing-cfg-13#section-8>  |
   |        |                           |           |
   | v6ur   | ietf-ipv6-unicast-routing | Section 9
<http://tools.ietf.org/html/draft-ietf-netmod-routing-cfg-13#section-9>  |
   |        |                           |           |
   | yang   | ietf-yang-types           | [RFC6991
<http://tools.ietf.org/html/rfc6991> ] |
   |        |                           |           |
   | inet   | ietf-inet-types           | [RFC6991
<http://tools.ietf.org/html/rfc6991> ] |
   +--------+---------------------------+-----------+
 
             Table 1: Prefixes and corresponding YANG modules

What changes did I make to the RIB section: 

1)Revised RIB Grammar in RBNF (section 6.1)

2)(section 6.2) Spot for the pdf graphic attached as 

    draft-hares-i2rs-info-rib-only-v7.pdf

3)(section 6.3) Yang tree structure (per yang documents)

4)Revised Usage - using simplified grammar

Basically: 

Basically the complex RIB-info RBNF grammar boils down to very few simply 

 statement.  The Yang Tree does not provide an easy way to design/debug 

 redundancy. I think that the use of the UML tools that create the Yang 

 modules/Yang Tree structures could speed time to market on the designs.

For example, all the I2RS RIB is simply 5 power-point slides, that 

then can be generated into Yang module.  This seems the normal 

progression of the process you started with the Yang-modules.

CAVEATS:

1)For all mistakes on the UML and diagrams blame me - this was the first
pass on the UML.  

 2) Some of the redundancies could have been fixed in other ways

3) I did Yang modules to demonstrate proof of concept

4) I suspect with Jamal and Joel Halpern's help (FoRCES gurus).. FoRCES 

Chair's /AD opinion: 

1)      Jeff is in favor of UML to improve the data model language 

2)      Ed Crabbe states he does not think informational models are useful -
why not go to the data modeling direct. 

3)      Adrian and Alia encouraged me to look at UML 

I'm in favor of Information models that can quickly express the concepts to
operators AND that can be used to generate code.   UML-2.0 tools are out
there for to/from yang models, and yang to/from code.   Seems like a
no-brainer tome to discuss 6 slides for the RIB info rather than the RBNF. 

What do you think?  

Sue Hares

---

From: Jamal Hadi Salim <[email-masked]>
Date: Tue, 29 Apr 2014 10:20:50 -0400

Sue,
Thanks for the hard work. We will take a look and probably drop in with a
ForCES data model representation.

cheers,
jamal

On Mon, Apr 28, 2014 at 6:30 PM, Susan Hares <[email-masked]> wrote:
>    | if     | ietf-interfaces           | [YANG-IF] |
>
>    |        |                           |           |
>
>    | ip     | ietf-ip                   | [YANG-IP] |
>
>    |        |                           |           |
>
>    | v4ur   | ietf-ipv4-unicast-routing | Section 8 |
>
>    |        |                           |           |
>
>    | v6ur   | ietf-ipv6-unicast-routing | Section 9 |
>
>    |        |                           |           |
>
>    | yang   | ietf-yang-types           | [RFC6991] |
>
>    |        |                           |           |
>
>    | inet   | ietf-inet-types           | [RFC6991] |
>
> 4)Revised Usage – using simplified grammar
>
>
>
> Basically:
>
>
>
> 1)For all mistakes on the UML and diagrams blame me – this was the first
> pass on the UML.
>
> 4) I suspect with Jamal and Joel Halpern’s help (FoRCES gurus).. FoRCES
>
>
>
> Chair’s /AD opinion:
>
> 2)      Ed Crabbe states he does not think informational models are useful –
> I’m in favor of Information models that can quickly express the concepts to
> _______________________________________________
> i2rs mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/i2rs
>